(*
    Edit undo item
    Copyright (c) 2002-2003,2004 Alessandro Scotti
    www.ascotti.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit EditUndoBuffer;

interface

uses
  Classes, Editor, UndoRedo;

type
  TEditUndoItem = class(TUndoRedoItem)
    FRow: integer;
    FAction: TTextDocumentAction;
    FLine: string;
    FData: TObject;
  public
    constructor Create( ARow: integer; AAction: TTextDocumentAction; ALine: string );
    destructor Destroy; override;

    property Action: TTextDocumentAction read FAction write FAction;
    property Data: TObject read FData write FData;
    property Line: string read FLine write FLine;
    property Row: integer read FRow write FRow;
  end;

  TEditInfoUndoItem = class(TUndoRedoItem)
    FCurCol: integer;
    FCurRow: integer;
   public
    constructor Create( ACurPos: TTextPosition );

    property CurCol: integer read FCurCol write FCurCol;
    property CurRow: integer read FCurRow write FCurRow;
  end;

implementation

constructor TEditUndoItem.Create( ARow: integer; AAction: TTextDocumentAction; ALine: string );
begin
  inherited Create;
  FRow := ARow;
  FAction := AAction;
  FLine := ALine;
  FData := nil;
end;

destructor TEditUndoItem.Destroy;
begin
  inherited Destroy;
end;

constructor TEditInfoUndoItem.Create( ACurPos: TTextPosition );
begin
  FCurCol := ACurPos.Col;
  FCurRow := ACurPos.Row;
end;

end.
